#include <iostream>
#include <vector>
#include <string>
#include <map>

using namespace std;
using ll = long long;

const int n = 1<<19;
int N = 0, Q;
struct node {
    ll sum = 0ll;
    ll cnt = 0ll;
} seg[2*n];
string s;
ll d;
map<string,int> pos;
map<string,ll> count;

void add() {
    pos[s] = N;
    int p = n + N;
    seg[p].sum = d;
    while (p > 1) {
        p >>= 1;
        seg[p].sum = seg[2*p].sum + seg[2*p+1].sum;
    }
    ++N;
    if (!count.count(s))
        count[s] = 0;
}
void rem() {
    int p = n + pos[s];
    pos.erase(s);
    seg[p].sum = 0;
    ll tot = seg[p].cnt;
    while (p > 1) {
        p >>= 1;
        seg[p].sum = seg[2*p].sum + seg[2*p+1].sum;
        tot += seg[p].cnt;
    }
    count[s] += tot;
}
void inc() {
    ll tl = seg[1].sum;
    ll full = d/tl, rem = d%tl;
    int p = n+N;
    while (p > 1) {
        if (p & 1) {
            seg[p-1].cnt += full;
        }
        p >>= 1;
    }
    p = n+N;
    while (p > 1) {
        if (p & 1) {
            if (seg[p-1].sum > rem) {
                --p;
                while (p < n) {
                    if (seg[2*p+1].sum > rem) {
                        p = 2*p+1;
                    }
                    else {
                        seg[2*p+1].cnt++;
                        rem -= seg[2*p+1].sum;
                        p = 2*p;
                    }
                }
                return;
            }
            else {
                seg[p-1].cnt++;
                rem -= seg[p-1].sum;
            }
        }
        p >>= 1;
    }
}
ll query() {
    int p = n + pos[s];
    ll tot = seg[p].cnt;
    while (p > 1) {
        p >>= 1;
        tot += seg[p].cnt;
    }
    return tot;
}
int main() {
    ios::sync_with_stdio(false);
    cin >> Q;
    while (Q--) {
        char type; cin >> type;
        if (type == 'L') {
            cin >> s >> d;
            if (pos.count(s)) {
                rem();
            }
            else {
                add();
            }
        }
        else if (type == 'P') {
            cin >> d;
            inc();
        }
        else {
            cin >> s;
            cout << count[s] + (pos.count(s) ? query() : 0ll) << endl;
        }
    }
    return 0;
}
